package dk.brics.string.grammar;

/**
 * Pair production [<tt>a -> b c</tt>].
 */
public class PairProduction extends Production {

    Nonterminal b, c;

    PairProduction(Nonterminal b, Nonterminal c) {
        this.b = b;
        this.c = c;
    }

    /**
     * Returns the first nonterminal.
     */
    public Nonterminal getNonterminal1() {
        return b;
    }

    /**
     * Returns the second nonterminal.
     */
    public Nonterminal getNonterminal2() {
        return c;
    }
    
    /**
     * Set the first nonterminal.
     * @author Jn Ruhalovsk
     */
    public void setNonterminal1(Nonterminal bb) {
        //this.b = new Nonterminal(bb.getKey());
    	this.b = bb;
    }

    /**
     * Set the second nonterminal.
     * @author Jn Ruhalovsk
     */
    public void setNonterminal2(Nonterminal cc) {
        //this.c = new Nonterminal(cc.getKey());
    	this.c = cc;
    }

    @Override
    public String toString() {
        return b + " " + c;
    }

    @Override
    public void visitBy(Nonterminal a, ProductionVisitor v) {
        v.visitPairProduction(a, this);
    }
}
