package dk.brics.string.grammar.operations;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Map;
import java.util.Map.Entry;

//import dk.brics.string.grammar.Entity;
import dk.brics.string.grammar.AutomatonProduction;
import dk.brics.string.grammar.EpsilonProduction;
import dk.brics.string.grammar.Grammar;
import dk.brics.string.grammar.Nonterminal;
import dk.brics.string.grammar.PairProduction;
import dk.brics.string.grammar.Production;
import dk.brics.string.grammar.ProductionVisitor;
import dk.brics.string.grammar.UnitProduction;
//import dk.brics.grammar.NonterminalEntity;
//import dk.brics.grammar.Production;
//import dk.brics.grammar.ProductionID;
//import dk.brics.grammar.TerminalEntity;
import dk.brics.string.grammar.ProductionVisitor;

public class Grammar2CNFGrammar {
	
	private class Pair<L,R> {
	    private L l;
	    private R r;
	    public Pair(L l, R r){
	        this.l = l;
	        this.r = r;
	    }
	    public L getL(){ return l; }
	    public R getR(){ return r; }
	    public void setL(L l){ this.l = l; }
	    public void setR(R r){ this.r = r; }
	}
	
	public Grammar2CNFGrammar() {}

	/**
	 * Converts a normalized grammar to grammar in Chomsky Normal Form.
	 * @param ng grammar to convert
	 * @return JSA grammar
	 * @throws Exception 
	 */
	public Grammar convert(Grammar ng) throws Exception {
		/*
		 * we must have epsilon removed grammar (but for start symbol is epsilon accessed)
		 */
		
		
		/*
		 * add new start symbol
		 */
		Grammar sg = new Grammar(ng.getNonterminals());
//		Nonterminal newStartnonterminal = sg.addNonterminal();//last added nonterminal is new start nonterminal
//		//Nonterminal newStartnonterminal = ng.getNonterminals().get(ng.getNumberOfNonterminals()-1);
//		sg.addUnitProduction(newStartnonterminal, ng.getNonterminal(0));
//		for (Nonterminal n  : sg.getNonterminals()) {
//			n.setKey(n.getKey()+1);
//		}
//		newStartnonterminal.setKey(0);
//		Production rp = new Production() {
//			
//			@Override
//			public void visitBy(Nonterminal a, ProductionVisitor v) {
//				// TODO Auto-generated method stub
//				
//			}
//		};
//		//removed epsilon production for old start symbol
//		for (Production p : ng.getNonterminals().get(0).getProductions()) {
//			if (p instanceof EpsilonProduction) {
//				sg.addEpsilonProduction(newStartnonterminal);
//				System.out.println("Addded epsilon production for start nonterminal");
//				rp = p;
//			}
//		}
//		sg.getNonterminals().get(0).getProductions().remove(rp);
//		System.out.println("SG: " + sg.toString());

		
		/*
		 * FIND epsilon productions and remove it
		 * these is made for normalized grammar
		 */
		

		/*
		 * MAke Chomsky normal form
		 */
		
		//indexes of removed productinos
		//Mapp<index of nonterminal, production>
		LinkedList<Map<Integer, Production>> removedProd = new LinkedList<Map<Integer, Production>>();
		
		//*********************************************************
		//**** remove "nonterminal -> nonterminal" productions = unit productions ****
		//************************************************************
		LinkedList<Pair<Nonterminal, Production>> nonterminal2nonterminalProductions = new LinkedList<Pair<Nonterminal, Production>>();
		for (int i=0; i<sg.getNumberOfNonterminals(); i++) {
			for (int j=0; j<sg.getNonterminals().get(i).getProductions().size(); j++) {
				Production p = sg.getNonterminals().get(i).getProductions().get(j);
				if (p instanceof UnitProduction) {
					nonterminal2nonterminalProductions.add(new Pair<Nonterminal, Production>(sg.getNonterminals().get(i), p));
				}
			}
		}
			
		//making CNF productions
//		LinkedList<Production> addedProductions = new LinkedList<Production>();
		ArrayList<Production> alp = new ArrayList<Production>();
		while (!nonterminal2nonterminalProductions.isEmpty()) {
			Pair<Nonterminal, Production> n2np = nonterminal2nonterminalProductions.pollFirst();
			//System.out.println("PR: " + n2np.getR().toString());
			//remove n2n production
			//System.out.println("removed?: " + n2np.getL() + " -> " + n2np.getR());
//			if (sg.getNonterminal(n2np.getL()).getProductions().remove(n2np.getR())) {
//				System.out.println("removed: " + n2np.getL() + " -> " + n2np.getR());
//				sg.getNonterminal(n2np.getL()).
//			}
			if (sg.removeProduction(n2np.getL().toString(), n2np.getR()) != null) {
				//System.out.println("removed: " + n2np.getL() + " -> " + n2np.getR());
			}
			
			//make new productions
			alp.addAll(sg.getNonterminal(n2np.getR().toString()).getProductions());
			for (Production p : alp) {
				if (p instanceof UnitProduction) {
					if (sg.getProduction(n2np.getL().toString(), ((UnitProduction) p)) == null) {//if not exist production
						if (!((UnitProduction) p).getNonterminal().equals(n2np.getL())) {
							sg.addUnitProduction(sg.getNonterminal(n2np.getL()), ((UnitProduction) p).getNonterminal());
							nonterminal2nonterminalProductions.add(new Pair<Nonterminal, Production>(sg.getNonterminal(n2np.getL()), p));
						}
					}
				}
				else if (p instanceof PairProduction) {
					if (sg.getProduction(n2np.getL().toString(), ((PairProduction) p)) == null) {//if not exist production
						//System.out.println("PAIR PRODUCTION: " + n2np.getL() + "->" + p.toString());
						sg.addPairProduction(sg.getNonterminal(n2np.getL()), ((PairProduction) p).getNonterminal1(), ((PairProduction) p).getNonterminal2());
					}
				}
				else if (p instanceof EpsilonProduction) {
					if (sg.getProduction(n2np.getL().toString(), ((EpsilonProduction) p)) == null) {//if not exist production
						//System.out.println("EPSILON PRODUCTION: " + n2np.getL() + "->" + p.toString());
						sg.addEpsilonProduction(sg.getNonterminal(n2np.getL()));
					}
				}
				else if (p instanceof AutomatonProduction) {
					if (sg.getProduction(n2np.getL().toString(), ((AutomatonProduction) p)) == null) {//if not exist production
						//System.out.println("AUTOMATON PRODUCTION: " + n2np.getL() + "->" + p.toString());
						sg.addAutomatonProduction(sg.getNonterminal(n2np.getL()), ((AutomatonProduction) p).getAutomaton());
					}
				}
				else {
					throw new Exception("form of grammar is not good"); 
				}
			}
			alp.clear();
			//System.out.println("SIZE N2N: " + nonterminal2nonterminalProductions.size());
		}

		
		System.out.println("GRAMMAR without A -> NONterminal \n" + sg.toString());
		
		//return new Grammar(dprg.getStart(), dprg.getProductions());
		return sg;
	}
	
}
