package dk.brics.string.grammar.operations;

import java.util.HashMap;
import java.util.Map;


import dk.brics.string.grammar.AutomatonProduction;
import dk.brics.string.grammar.BinaryProduction;
import dk.brics.string.grammar.EpsilonProduction;
import dk.brics.string.grammar.Grammar;
import dk.brics.string.grammar.Nonterminal;
import dk.brics.string.grammar.PairProduction;
import dk.brics.string.grammar.Production;
import dk.brics.string.grammar.UnaryProduction;
import dk.brics.string.grammar.UnitProduction;

/**
 * JSAGrammarConnestor connect(join) 2 grammars and make new one JSA grammar
 * @author Jn Ruhalovsk
 *
 */
public class JSAGrammarConnector {
	
	private Map<String,dk.brics.string.grammar.Nonterminal> nt_map;
	
	Grammar g1;
	Grammar g2;
	
	public JSAGrammarConnector(Grammar g1, Grammar g2) {
		this.g1 = g1;
		this.g2 = g2;
	}
	
	public Grammar returnConnectedGrammar () {
		Grammar g = new Grammar();
		nt_map = new HashMap<String,dk.brics.string.grammar.Nonterminal>();

		for (Nonterminal n : g1.getNonterminals()) {
    		//g.addNonterminal(n.getKey());
			getNonterminal(n.toString(), g);//this add nonterminal
    		System.out.println("VELKOST PRAVEJ STRANY pre " + n.toString() + " : " + n.getProductions().size());
        	for (Production p : n.getProductions()) {
        		Nonterminal nn = getNonterminal(n.toString(), g);
        		if (p instanceof UnitProduction) {
        			Nonterminal n1 = ((UnitProduction) p).getNonterminal();
        			g.addUnitProduction(nn, getNonterminal(n1.toString(), g) );
        		}
        		else if (p instanceof UnaryProduction) {
        			Nonterminal n1 = ((UnaryProduction) p).getNonterminal();
        			g.addUnaryProduction(nn, ((UnaryProduction) p).getOperation(), getNonterminal(n1.toString(), g) );
        		}
        		else if (p instanceof BinaryProduction) {
        			Nonterminal n1 = ((BinaryProduction) p).getNonterminal1();
        			Nonterminal n2 = ((BinaryProduction) p).getNonterminal2();
        			g.addBinaryProduction(nn, ((BinaryProduction) p).getOperation(), getNonterminal(n1.toString(), g), getNonterminal(n2.toString(), g));
        		}
        		else if (p instanceof AutomatonProduction) {
        			g.addAutomatonProduction(nn, ((AutomatonProduction) p).getAutomaton());
        		}
        		else if (p instanceof EpsilonProduction) {
        			g.addEpsilonProduction(nn);
        		}
        		else if (p instanceof PairProduction) {
        			Nonterminal n1 = ((PairProduction) p).getNonterminal1();
        			Nonterminal n2 = ((PairProduction) p).getNonterminal2();
        			g.addPairProduction(nn, getNonterminal(n1.toString(), g), getNonterminal(n2.toString(), g));
        		}
        	}
		}
		
		for (Nonterminal n : g2.getNonterminals()) {
			//g.addNonterminal(n.getKey());
			getNonterminal(n.toString(), g);//this add nonterminal
    		System.out.println("VELKOST PRAVEJ STRANY pre " + n.toString() + " : " + n.getProductions().size());
        	for (Production p : n.getProductions()) {
        		Nonterminal nn = getNonterminal(n.toString(), g);
        		if (p instanceof UnitProduction) {
        			Nonterminal n1 = ((UnitProduction) p).getNonterminal();
        			g.addUnitProduction(nn, getNonterminal(n1.toString(), g) );
        		}
        		else if (p instanceof UnaryProduction) {
        			Nonterminal n1 = ((UnaryProduction) p).getNonterminal();
        			g.addUnaryProduction(nn, ((UnaryProduction) p).getOperation(), getNonterminal(n1.toString(), g) );
        		}
        		else if (p instanceof BinaryProduction) {
        			Nonterminal n1 = ((BinaryProduction) p).getNonterminal1();
        			Nonterminal n2 = ((BinaryProduction) p).getNonterminal2();
        			g.addBinaryProduction(nn, ((BinaryProduction) p).getOperation(), getNonterminal(n1.toString(), g), getNonterminal(n2.toString(), g));
        		}
        		else if (p instanceof AutomatonProduction) {
        			g.addAutomatonProduction(nn, ((AutomatonProduction) p).getAutomaton());
        		}
        		else if (p instanceof EpsilonProduction) {
        			g.addEpsilonProduction(nn);
        		}
        		else if (p instanceof PairProduction) {
        			Nonterminal n1 = ((PairProduction) p).getNonterminal1();
        			Nonterminal n2 = ((PairProduction) p).getNonterminal2();
        			g.addPairProduction(nn, getNonterminal(n1.toString(), g), getNonterminal(n2.toString(), g));
        		}
        	}
		}
		System.out.println("NT from JSAGRammarConnector: " + nt_map.toString());
		
		return g;
	}
	
	/**
	 * Looks up or creates nonterminal.
	 */
	private dk.brics.string.grammar.Nonterminal getNonterminal(String n, dk.brics.string.grammar.Grammar jg) {
		dk.brics.string.grammar.Nonterminal jn = nt_map.get(n);
		if (jn == null)
			jn = jg.addNonterminal();
		nt_map.put(n, jn);
		return jn;
	}
	
	/**
	 * Returns map from old nonterminals to new nonterminals from the last conversion.
	 * @return nonterminal map
	 */
	public Map<String,dk.brics.string.grammar.Nonterminal> getNonterminalMap() {
		return nt_map;
	}
	
	

}
